#
# Retrieves CVS files from sourceforge web interface (might work with others sites using viewcvs)
#
from httpget import *
import HTMLParser,types,os,os.path,sys,filter

VIEW_URL="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/"
CHECKOUT_URL="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/*checkout*/"

class pageGrabber:
    # Custom HTML parser (only handles the anchor tag)
    class myHTMLParser(HTMLParser.HTMLParser):
        def __init__(self):
            HTMLParser.HTMLParser.__init__(self)
            self.entries=[]
            
        def handle_starttag(self,tag, attrs):
            tag=tag.lower()
            #print "start tag:",tag,attrs
            if(tag=="a"):
                if(len(attrs)==2):
                   #attrs[1][1]print attrs,type(attrs[0]),type
                   if(type(attrs[0])==types.TupleType and type(attrs[1])==types.TupleType):
                       if(attrs[0][0].lower()=="name" and attrs[1][0].lower()=="href"):
                           self.entries.append(attrs[1][1])


    def __init__(self,proxy,username,password,project,dest_dir):
        self.entries=[]
        self.proxy=proxy
        self.username=username
        self.password=password
        self.project=project
        self.dest_dir=dest_dir
        rootdir=[]
        rootdir.append("/"+project)
        self.mkdirs(rootdir)
    
    def mkdirs(self,entries,level=''):
        #print "dest_dir:",self.dest_dir
        print "level:",level
        
        # Create the base directory as well
        basedir=(self.dest_dir+"/"+self.project+"/"+level+"/").replace("//","/")
        basedir=filter.filterstr(basedir)
        if(not os.path.exists(basedir)):
           os.makedirs(basedir)
        
        
        # Plus any existing sub-directories
        for f in entries:
              #fullpath=os.path.join(self.dest_dir,level,self.project,f)
              fullpath=(basedir+f).replace("//","/")
              fillpath=filter.filterstr(fullpath)
              print fullpath
              if(os.path.exists(fullpath)):
                  if(not os.path.isdir(fullpath)):
                     print "Error at creating directory ",fullpath
                     return(1)
              else:
                  print "Creating directory ",fullpath
                  os.makedirs(fullpath)
 
       
    def start(self,level=''):
        parser=self.myHTMLParser()
        http=httpget(self.proxy,self.username,self.password)
        print "parsing ",VIEW_URL+self.project+level
        htmldata=http.get(VIEW_URL+self.project+level)
        parser.feed(htmldata)
        parser.close()
        dirs=([f for f in parser.entries if f[len(f)-1]=='/'])
        files=([f for f in parser.entries if f[len(f)-1]!='/'])
        
        # CVSROOT not really necessary...
        if("CVSROOT/" in dirs):
            dirs.remove("CVSROOT/")
                       
        self.mkdirs(dirs,level)
        print "+dirs: ",dirs
        for dirname in dirs:
           self.start(level+"/"+dirname)
        print "Retrieving files...",
        for f in files:
           furl=CHECKOUT_URL+self.project+"/"+level+"/"+f
           fname=filter.filterstr(self.dest_dir+"/"+self.project+"/"+level+"/"+f).replace("//","/")
           print f,
           http.save(furl,fname)
        print
        return(parser.entries)


 

# Main entry
if(len(sys.argv)<5):
   print  """Usage: sfcvs {proxy username} {proxy password} {project name} {destination directory}
   (use # for proxy username and password if they aren't used)
   Example: sfcvs proxy.blah.com homa_si bart boa-constructor c:/tmp"""
   print sys.argv
   sys.exit(1)
   
proxy=sys.argv[1]
username=sys.argv[2]
password=sys.argv[3]
project=sys.argv[4]
dest_dir=sys.argv[5]


cvs=pageGrabber(proxy,username,password,project,dest_dir)
entries=cvs.start()
print entries
